<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset='utf-8'>
    <title>Lucky Dice Casino</title>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <style>
        .picture-cover {
            background-image: url(LuckyDiceImages/cover.jpg);
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>

<body>
    <div class="container-fluid">
        <div class="picture-cover"></div>
    </div>


    <div class="container">
        <div class="row ">
            <div class="col-sm-5">
                <div class="row form-group">
                    <div class="col-12">
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label>Username</label>
                    </div>
                    <div class="col-8">
                        <input id="inp_user_name" class="form-control" type="text">
                        <div id="user_name_false" style="color:red; font-size:15px"></div>
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-4 ">
                        <label>Firstname</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp_first_name" class="form-control" type="text">
                        <div id="first_name_false" style="color:red; font-size:15px"></div>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label>Lastname</label>
                    </div>
                    <div class="col-8 ">
                        <input id="inp_last_name" class="form-control" type="text">
                        <div id="last_name_false" style="color:red; font-size:15px"></div>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-4">
                        <label></label>
                    </div>
                    <div class="col-8">
                        <p id="p-devcampdemo-notification-validate"></p>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 text-center ">
                <div class="row form-group">
                    <div class="col-12">
                        <input type="button" id="btn-dice" class="btn btn-success button-width w-75" value="Ném">
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-12 ">
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12" id="p_none" style="display: none">
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>

            </div>
            <div class="col-sm-3 text-center">
                <div class="row form-group">
                    <div class="col-12 ">
                        <h3 class="text-danger">Voucher</h3>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
                </div>

                <div class="row form-group">
                    <div class="col-12">
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/no-present.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="form-group">
            <div class="row text-center">
                <div class="col-12 ">
                    <input id="btn-dice-history" class="btn btn-primary button-width w-25" value="Dice History"
                        type="button">
                    <input id="btn-voucher-history" class="btn btn-success button-width w-25" value="Voucher History"
                        type="button">
                    <input id="btn-present-history" class="btn btn-success button-width w-25" value="Present History"
                        type="button">
                </div>
            </div>
        </div>

        <div class="row ">
            <div class="col-12 ">
                <table id="history-placeholder-table" class="table table-striped table-hover border">
                    <thead>
                        <tr>
                            <th>Lượt</th>
                            <th>Dice</th>
                        </tr>
                    </thead>

                    <tbody>
                        <tr>
                            <td>1</td>
                            <td>2</td>
                        </tr>
                        <tr>
                            <td>2</td>
                            <td>6</td>
                        </tr>
                        <tr>
                            <td>3</td>
                            <td>4</td>
                        </tr>
                        <tr>
                            <td>4</td>
                            <td>5</td>
                        </tr>
                        <tr>
                            <td>5</td>
                            <td>4</td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</body>

<script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

    //base url
    const vBASE_URL = "/devcamp-lucky-dice";
    const vUTF8_TEXT_APPLICATION_HEADER = "application/json;charset=UTF-8";


    // Tạo biến toàn cực đối tượng để truyền dữ liệu giữa các bước
    const gUserObj = {
        username: "",
        firstname: "",
        lastname: ""
    }
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    $(document).ready(function () {
        $('#btn-dice').on('click', function () {
            onBtnNemClick()
        })

    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnNemClick() {

        //  Bước 1 :  Thu thập dữ liệu
        getData(gUserObj)
        //    Bước 2 : Kiểm tra dữ liệu
        var vIsCheck = validateData(gUserObj);
        if (vIsCheck) {

            //   Bước 3 : gọi API sever
            callApiSeverDice(gUserObj);
        }
    }


    // hàm sự kiện nút lịch sử tung xúc xắc
    $('#btn-voucher-history').on('click', function () {

        console.log("%c Nút Voucher History được ấn", "color:green");

        // khi ấn nút sẽ xóa dữ liệu có sẵn trong bảng
        var vTable = document.getElementById("history-placeholder-table")

        while (vTable.rows.length > 1) {
            vTable.deleteRow(1);
        }
        //  Bước 1 :  Thu thập dữ liệu
        getData(gUserObj);
        //    Bước 2 : Kiểm tra dữ liệu
        var vIsCheck = validateData(gUserObj);
        if (vIsCheck) {

            var vXmlHttpVoucherHistory = new XMLHttpRequest();
            //   Bước 3 : gọi API sever

            callVoucherHistory(vXmlHttpVoucherHistory, gUserObj);

            vXmlHttpVoucherHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) { // Nếu nhận trạng thái của reponse ready và ok
                    //   Bước 4 : xử lý response trả về sever
                    console.log(vXmlHttpVoucherHistory.responseText);
                    var vReponsiveHistoryDice = JSON.parse(vXmlHttpVoucherHistory.responseText);
                    console.log(vReponsiveHistoryDice);
                    showVoucherHistory(vReponsiveHistoryDice);
                }
            }
        }

    });
    // Btn voucher
    $('#btn-present-history').on('click', function () {

        console.log("%c Nút Dice History được ấn", "color:red");

        // khi ấn nút sẽ xóa dữ liệu có sẵn trong bảng
        var vTable = document.getElementById("history-placeholder-table")

        while (vTable.rows.length > 1) {
            vTable.deleteRow(1);
        }
        //  Bước 1 :  Thu thập dữ liệu
        getData(gUserObj);
        //    Bước 2 : Kiểm tra dữ liệu
        var vIsCheck = validateData(gUserObj);
        if (vIsCheck) {

            var vXmlHttpVoucherHistory = new XMLHttpRequest();
            //   Bước 3 : gọi API sever

            callPresentHistory(vXmlHttpVoucherHistory, gUserObj);

            vXmlHttpVoucherHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) { // Nếu nhận trạng thái của reponse ready và ok
                    //   Bước 4 : xử lý response trả về sever
                    console.log(vXmlHttpVoucherHistory.responseText);
                    var vReponsiveHistoryDice = JSON.parse(vXmlHttpVoucherHistory.responseText);
                    console.log(vReponsiveHistoryDice);
                    showPresentHistory(vReponsiveHistoryDice);
                }
            }
        }

    });
    $('#btn-dice-history').on('click', function () {

        console.log("%c Nút Dice History được ấn", "color:red");

        // khi ấn nút sẽ xóa dữ liệu có sẵn trong bảng
        var vTable = document.getElementById("history-placeholder-table")

        while (vTable.rows.length > 1) {
            vTable.deleteRow(1);
        }
        //  Bước 1 :  Thu thập dữ liệu
        getData(gUserObj);
        //    Bước 2 : Kiểm tra dữ liệu
        var vIsCheck = validateData(gUserObj);
        if (vIsCheck) {

            var vXmlHttpVoucherHistory = new XMLHttpRequest();
            //   Bước 3 : gọi API sever

            callApiHistoryDice(vXmlHttpVoucherHistory, gUserObj);

            vXmlHttpVoucherHistory.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) { // Nếu nhận trạng thái của reponse ready và ok
                    //   Bước 4 : xử lý response trả về sever
                    console.log(vXmlHttpVoucherHistory.responseText);
                    var vReponsiveHistoryDice = JSON.parse(vXmlHttpVoucherHistory.responseText);
                    console.log(vReponsiveHistoryDice);
                    showDiceHistory(vReponsiveHistoryDice);
                }
            }
        }

    })

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

    //CÁC HÀM XÚC XẮC

    function getData(paramDataUser) {
        var vInputUserName = $("#inp_user_name");
        var vInputFirstName = $("#inp_first_name");
        var vInputLastName = $("#inp_last_name");

        paramDataUser.username = vInputUserName.val().trim();
        paramDataUser.firstname = vInputFirstName.val().trim();
        paramDataUser.lastname = vInputLastName.val().trim();

    }

    //         Hàm kiểm tra dữ liệu
    function validateData(paramDataUser) {

        if (paramDataUser.username == "") {
            $('#inp_user_name').addClass("is-invalid").removeClass("is-valid");
            $('#user_name_false').html("Hãy nhập user name");
            console.log("Cần nhập User Name!!!");
            alert("Cần nhập User Name!!!");
            return false;

        } else {
            $('#inp_user_name').addClass("is-valid").removeClass("is-invalid");
            $('#user_name_false').hide();
        }




        if (paramDataUser.firstname == "") {
            $('#inp_first_name').addClass("is-invalid").removeClass("is-valid");
            $('#first_name_false').html("Hãy nhập first name");
            console.log("Cần nhập First Name!!!");
            alert("Cần nhập First Name!!!");
            return false;

        } else {
            $('#inp_first_name').addClass("is-valid").removeClass("is-invalid");
            $('#first_name_false').hide();
        }



        if (paramDataUser.lastname == "") {
            $('#inp_last_name').addClass("is-invalid").removeClass("is-valid");
            $('#last_name_false').html("Hãy nhập last name");
            console.log("Cần nhập Last Name!!!");
            alert("Cần nhập Last Name!!!");
            return false;

        } else {
            $('#inp_last_name').addClass("is-valid").removeClass("is-invalid");
            $('#last_name_false').hide();
        }

        return true;
    }

    // Hàm xall API
    function callApiSeverDice(paramDataUser) {

        $.ajax({
            url: vBASE_URL + "/dice",
            type: "POST",
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(paramDataUser),
            success: function (response) {
                console.log(response);

                //Hiển thị
                processResponse(response);
            },
            error: function (ajaxContent) {
                console.log(ajaxContent);
            }
        })
    }

    //      CÁC HÀM XỬ LÝ RESPONSE TRẢ VỀ THÀNH CÔNG
    function processResponse(paramXmlHttpDice) {
        "user strict";

        console.log(paramXmlHttpDice);

        //  get result dice
        var vDiceReady = paramXmlHttpDice.dice;
        console.log("dice result: " + vDiceReady);

        // gọi hàm hiển thị dice
        changeDice(vDiceReady);

        //gọi hàm hiển thị lời nhắn
        changeThongBao(vDiceReady);

        //gọi hàm hiển thị voucher
        changeVoucherId(paramXmlHttpDice);

        //gọi hàm hiển thị ảnh phần thưởng
        changeGift(paramXmlHttpDice);
    }

    function changeDice(paramDice) {
        "user strict";
        var vImgDice = $("#img-dice");

        switch (paramDice) {
            case 1:
                vImgDice.attr("src", "LuckyDiceImages/1.png");
                break;
            case 2:
                vImgDice.attr("src", "LuckyDiceImages/2.png");
                break;
            case 3:
                vImgDice.attr("src", "LuckyDiceImages/3.png");
                break;
            case 4:
                vImgDice.attr("src", "LuckyDiceImages/4.png");
                break;
            case 5:
                vImgDice.attr("src", "LuckyDiceImages/5.png");
                break;
            case 6:
                vImgDice.attr("src", "LuckyDiceImages/6.png");
                break;
        }
    }

    function changeThongBao(paramDice) {
        "user strict";

        // hiển thị thẻ P chúc mừng
        var vElementPChucMung = $("#p_none");
        vElementPChucMung.css("display", "block");

        // Hiển thị lời chúc theo số điểm xúc xắc
        var vThongBao = $("#p-notification-dice");
        if (paramDice < 4) {
            vThongBao.html("Chúc bạn may mắn lần sau !!!");
            vThongBao.css("color", "blue");
        } else {
            vThongBao.html("Chúc mừng bạn hãy chơi tiếp lần nữa nha !!!")
            vThongBao.css({
                "color": "red",
                "font-weight": "bold"
            });
        }
    }

    function changeVoucherId(paramResponeVoucher) {
        "user strict";

        var vPVoucherId = $("#p-voucher-id");
        var vPVoucherPercent = $("#p-voucher-percent");

        if (paramResponeVoucher.voucher != null) {
            vPVoucherId.html("ID: " + paramResponeVoucher.voucher.code);
            vPVoucherPercent.html("Giảm giá: " + paramResponeVoucher.voucher.discount + "%");
        } else {
            vPVoucherId.empty();
            vPVoucherPercent.empty();
        }
    }

    function changeGift(paramResponePrize) {
        var vImgPresent = $("#img-present");
        // vImgPresent.attr("src", "LuckyDiceImages/no-present.jpg");
        var vTenPhanThuong = paramResponePrize.prize.name;
        switch (vTenPhanThuong) {
            case null:
                vImgPresent.attr("src", "LuckyDiceImages/no-present.jpg");
                break;
            case "Mũ":
                vImgPresent.attr("src", "LuckyDiceImages/hat.jpg");
                break;
            case "Áo":
                vImgPresent.attr("src", "LuckyDiceImages/t-shirt.jpg");
                break;
            case "Bike":
                vImgPresent.attr("src", "LuckyDiceImages/motobike.jpg");
                break;
            case "Car":
                vImgPresent.attr("src", "LuckyDiceImages/car.jpg");
                break;
            default:
                vImgPresent.attr("src", "LuckyDiceImages/no-present.jpg");
        }
    }


    //  HISTORY DICE -- LỊCH SỬ TUNG XÚC XẮC:

    // Hàm gọi API lấy lịch xử tung xức xắc từ sever
    function callApiHistoryDice(paramXmlHttpDiceHistory, paramDataUser) {
        paramXmlHttpDiceHistory.open("GET", vBASE_URL + "/dice-history?username=" + paramDataUser.username, true)
        paramXmlHttpDiceHistory.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttpDiceHistory.send(JSON.stringify(paramDataUser)); //    Chuyển JSON object sang string
    }

    // Hàm hiển thị lịch sử tung xúc xắc
    function showDiceHistory(paramResposeDiceHistory) {

        // Table Header
        var vTable = document.getElementById("history-placeholder-table");
        vTable.rows[0].cells[0].innerHTML = "Lượt";
        vTable.rows[0].cells[1].innerHTML = "Kết quả";

        // hiển thị lịch sử ra tbody
        var vTbody = vTable.getElementsByTagName("tbody")[0];
        vTbody.innerHTML = "";

        for (let bI = 0; bI < paramResposeDiceHistory.data.length; bI++) {
            var vNewRow = vTbody.insertRow(-1);
            var vNewNumCells = vNewRow.insertCell(0);
            var vNewDiceCells = vNewRow.insertCell(1);

            // hiển thị ra HTML
            vNewNumCells.innerHTML = bI + 1;
            vNewDiceCells.innerHTML = paramResposeDiceHistory.data[bI].dice;
        }
    }

    function callPresentHistory(paramXmlHttpDiceHistory, paramDataUser) {
        paramXmlHttpDiceHistory.open("GET", vBASE_URL + "/prizeHistory?username=" + paramDataUser.username, true)
        paramXmlHttpDiceHistory.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttpDiceHistory.send(JSON.stringify(paramDataUser)); //    Chuyển JSON object sang string
    }

    // Hàm hiển thị lịch sử tung xúc xắc
    function showPresentHistory(paramResponse) {

        // Table Header
        var vTable = document.getElementById("history-placeholder-table");
        vTable.rows[0].cells[0].innerHTML = "Lượt";
        vTable.rows[0].cells[1].innerHTML = "Kết quả";

        // hiển thị lịch sử ra tbody
        var vTbody = vTable.getElementsByTagName("tbody")[0];
        vTbody.innerHTML = "";

        for (let bI = 0; bI < paramResponse.data.length; bI++) {
            var vNewRow = vTbody.insertRow(-1);
            var vNewNumCells = vNewRow.insertCell(0);
            var vNewDiceCells = vNewRow.insertCell(1);

            // hiển thị ra HTML
            vNewNumCells.innerHTML = bI + 1;
            vNewDiceCells.innerHTML = paramResponse.data[bI].prize.name;
        }
    };

    function callVoucherHistory(paramXmlHttpDiceHistory, paramDataUser) {
        paramXmlHttpDiceHistory.open("GET", vBASE_URL + "/voucher-history?username=" + paramDataUser.username, true)
        paramXmlHttpDiceHistory.setRequestHeader("Content-Type", vUTF8_TEXT_APPLICATION_HEADER);
        paramXmlHttpDiceHistory.send(JSON.stringify(paramDataUser)); //    Chuyển JSON object sang string
    }

    // Hàm hiển thị lịch sử tung xúc xắc
    function showVoucherHistory(paramResponse) {

        // Table Header
        var vTable = document.getElementById("history-placeholder-table");
        vTable.rows[0].cells[0].innerHTML = "Mã voucher";
        vTable.rows[0].cells[1].innerHTML = "Phần trăm giảm giá";

        // hiển thị lịch sử ra tbody
        var vTbody = vTable.getElementsByTagName("tbody")[0];
        vTbody.innerHTML = "";

        for (let bI = 0; bI < paramResponse.data.length; bI++) {
            var vNewRow = vTbody.insertRow(-1);
            var vNewNumCells = vNewRow.insertCell(0);
            var vNewDiceCells = vNewRow.insertCell(1);

            // hiển thị ra HTML
            vNewNumCells.innerHTML = paramResponse.data[bI].voucher.code;
            vNewDiceCells.innerHTML = paramResponse.data[bI].voucher.discount;
        }
    }
</script>

</html>